/**
 * JORM: an implementation of a generic mapping system for persistent Java
 *       objects. Two mappings are supported: to RDBMS and to binary files.
 * Copyright (C) 2001-2004 France Telecom R&D - INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: jorm-team@objectweb.org
 *
 */

package jorm;

import org.objectweb.jorm.naming.api.PBinder;
import org.objectweb.jorm.naming.api.PExceptionNaming;
import org.objectweb.jorm.api.PExceptionProtocol;
import org.objectweb.jorm.api.PException;
import org.objectweb.jorm.naming.api.PName;
import org.objectweb.jorm.naming.api.PNameCoder;
import org.objectweb.jorm.api.PSerializable;
import org.objectweb.jorm.api.PAccessor;
import org.objectweb.jorm.api.PAccessorGen;
import org.objectweb.jorm.api.PClassMapping;

public class Olstore_userSerializable implements PSerializable, Olstore_userAccessor {

	//the pname of the object
	protected String pName;
	
		protected  String address;
			protected java.lang.String emailAdd;
			protected java.lang.String fname;
			protected  String friends;
			protected  String jonasCMRFriend_User;
			protected java.lang.String lname;
			protected  String orders;
			protected java.lang.String passwd;
			protected java.lang.String phoneNum;
			protected  String purchased;
			protected java.lang.String role;
			protected java.lang.String username;
	
	public String setPName(PName pName){
		if(pName.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				this.pName  = pName.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			this.pName = "null";
		}
		return this.pName;
	}
	
	public PName getPName(PBinder pnc) throws PExceptionNaming{
		try{
			return pnc.decodeString(pName);
		}catch (Exception e) {
              throw new PExceptionNaming("Cannot decode to a PName: " + e.getMessage());
        }
	}
	
	public String getClassName(){
		return "jorm.Olstore_user";
	}
	

	public void paSetAddress(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				address = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			address = "null";
		}
	}
	
	public PName paGetAddress(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("address");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(address);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetEmailAdd(java.lang.String val){
		emailAdd = val;
	}
	public java.lang.String paGetEmailAdd() {
		return emailAdd;
	}

	public void paSetFname(java.lang.String val){
		fname = val;
	}
	public java.lang.String paGetFname() {
		return fname;
	}

	public void paSetFriends(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				friends = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			friends = "null";
		}
	}
	
	public PName paGetFriends(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("friends");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(friends);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetJonasCMRFriend_User(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				jonasCMRFriend_User = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			jonasCMRFriend_User = "null";
		}
	}
	
	public PName paGetJonasCMRFriend_User(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("jonasCMRFriend_User");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(jonasCMRFriend_User);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetLname(java.lang.String val){
		lname = val;
	}
	public java.lang.String paGetLname() {
		return lname;
	}

	public void paSetOrders(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				orders = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			orders = "null";
		}
	}
	
	public PName paGetOrders(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("orders");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(orders);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetPasswd(java.lang.String val){
		passwd = val;
	}
	public java.lang.String paGetPasswd() {
		return passwd;
	}

	public void paSetPhoneNum(java.lang.String val){
		phoneNum = val;
	}
	public java.lang.String paGetPhoneNum() {
		return phoneNum;
	}

	public void paSetPurchased(PName val, Object connection){
		if(val.codingSupported((short) PNameCoder.CTSTRING)){
			try{
				purchased = val.encodeString();
			}
			catch(Exception e){
			}
		}
		else{
			purchased = "null";
		}
	}
	
	public PName paGetPurchased(Object hints){
		PNameCoder pnc;
		if(hints instanceof PClassMapping){
			PClassMapping pcm = (PClassMapping) hints;
			pnc = pcm.getPNameCoder("purchased");
		}
		else{
			if(hints instanceof PNameCoder){
				pnc = (PNameCoder) hints;
			}
			else
				return null;
		}
		try{
			return pnc.decodeString(purchased);
		}
		catch(PException e){
			return null;
		}
	}

	public void paSetRole(java.lang.String val){
		role = val;
	}
	public java.lang.String paGetRole() {
		return role;
	}

	public void paSetUsername(java.lang.String val){
		username = val;
	}
	public java.lang.String paGetUsername() {
		return username;
	}

	public Object getMemoryInstance(){
		return this;
	}
	
	
	public String toString(){
		StringBuffer s = new StringBuffer();
		s.append("data(");
					s.append(address + ",  ");
					s.append(emailAdd + ",  ");
					s.append(fname + ",  ");
					s.append(friends + ",  ");
					s.append(jonasCMRFriend_User + ",  ");
					s.append(lname + ",  ");
					s.append(orders + ",  ");
					s.append(passwd + ",  ");
					s.append(phoneNum + ",  ");
					s.append(purchased + ",  ");
					s.append(role + ",  ");
					s.append(username + ",  ");
				s.append(pName + ")");
		return s.toString();
	}
	
	
	public void read(PClassMapping pcm, PAccessor pa) throws PException{
		Olstore_userAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PException("Accessor must not be null");
		else if (pa instanceof Olstore_userAccessor)
			paccessor = (Olstore_userAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PException("Wrong type of accessor: " + pa);
	 	try {	
			if(paccessor != null){
											paccessor.paSetAddress(paGetAddress(pcm), null);
															paccessor.paSetEmailAdd(paGetEmailAdd());
															paccessor.paSetFname(paGetFname());
															paccessor.paSetFriends(paGetFriends(pcm), null);
															paccessor.paSetJonasCMRFriend_User(paGetJonasCMRFriend_User(pcm), null);
															paccessor.paSetLname(paGetLname());
															paccessor.paSetOrders(paGetOrders(pcm), null);
															paccessor.paSetPasswd(paGetPasswd());
															paccessor.paSetPhoneNum(paGetPhoneNum());
															paccessor.paSetPurchased(paGetPurchased(pcm), null);
															paccessor.paSetRole(paGetRole());
															paccessor.paSetUsername(paGetUsername());
							 			}
 			else{
	  		 						 			        		//paccessorGen.paSetStringField("emailAdd", paGetEmailAdd(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("fname", paGetFname(pcm), null);
	        			 						 						 			        		//paccessorGen.paSetStringField("lname", paGetLname(pcm), null);
	        			 						 			        		//paccessorGen.paSetStringField("passwd", paGetPasswd(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("phoneNum", paGetPhoneNum(pcm), null);
	        			 						 			        		//paccessorGen.paSetStringField("role", paGetRole(pcm), null);
	        			 			        		//paccessorGen.paSetStringField("username", paGetUsername(pcm), null);
	        			        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
	
	public void write(PClassMapping pcm, PAccessor pa) throws PException{
		Olstore_userAccessor paccessor = null;
		PAccessorGen paccessorGen = null;
		if (pa == null)
			throw new PExceptionProtocol("Accessor must not be null");
		else if (pa instanceof Olstore_userAccessor)
			paccessor = (Olstore_userAccessor) pa;
		else if (pa instanceof PAccessorGen)
			paccessorGen = (PAccessorGen) pa;
		else
			throw new PExceptionProtocol("Wrong type of accessor: " + pa);
		try {	
			if(paccessor != null){
											paSetAddress(paccessor.paGetAddress(pcm), null);
															paSetEmailAdd(paccessor.paGetEmailAdd());
															paSetFname(paccessor.paGetFname());
															paSetFriends(paccessor.paGetFriends(pcm), null);
															paSetJonasCMRFriend_User(paccessor.paGetJonasCMRFriend_User(pcm), null);
															paSetLname(paccessor.paGetLname());
															paSetOrders(paccessor.paGetOrders(pcm), null);
															paSetPasswd(paccessor.paGetPasswd());
															paSetPhoneNum(paccessor.paGetPhoneNum());
															paSetPurchased(paccessor.paGetPurchased(pcm), null);
															paSetRole(paccessor.paGetRole());
															paSetUsername(paccessor.paGetUsername());
							 			}
 			else{
	  		 						 				        	//	paSetStringField(emailAdd, paccessorGen.paGetEmailAdd());
        		//paSetStringField("emailAdd", paccessorGen.paGetStringField("emailAdd"));
        		//paSetEmailAdd(paccessorGen.paGetStringField("emailAdd"), null);
	        			 				        	//	paSetStringField(fname, paccessorGen.paGetFname());
        		//paSetStringField("fname", paccessorGen.paGetStringField("fname"));
        		//paSetFname(paccessorGen.paGetStringField("fname"), null);
	        			 						 						 				        	//	paSetStringField(lname, paccessorGen.paGetLname());
        		//paSetStringField("lname", paccessorGen.paGetStringField("lname"));
        		//paSetLname(paccessorGen.paGetStringField("lname"), null);
	        			 						 				        	//	paSetStringField(passwd, paccessorGen.paGetPasswd());
        		//paSetStringField("passwd", paccessorGen.paGetStringField("passwd"));
        		//paSetPasswd(paccessorGen.paGetStringField("passwd"), null);
	        			 				        	//	paSetStringField(phoneNum, paccessorGen.paGetPhoneNum());
        		//paSetStringField("phoneNum", paccessorGen.paGetStringField("phoneNum"));
        		//paSetPhoneNum(paccessorGen.paGetStringField("phoneNum"), null);
	        			 						 				        	//	paSetStringField(role, paccessorGen.paGetRole());
        		//paSetStringField("role", paccessorGen.paGetStringField("role"));
        		//paSetRole(paccessorGen.paGetStringField("role"), null);
	        			 				        	//	paSetStringField(username, paccessorGen.paGetUsername());
        		//paSetStringField("username", paccessorGen.paGetStringField("username"));
        		//paSetUsername(paccessorGen.paGetStringField("username"), null);
	        			        	 }  
		}
 		catch (PException pe) {
			throw pe;
		} catch (Exception e) {
			throw new PException(e.toString());
		} 
	}
}